<?php
date_default_timezone_set("Asia/Jakarta");
session_start();
if($_SESSION['status'] != "administrator_logedin"){
    header("location:../index.php?alert=belum_login");
}

include '../koneksi.php';

// deklarasi parameter koneksi database
//$server   = "localhost";
//$username = "mitrakop_sdb_user";
//$password = "Paktris4464100%";
//$database = "mitrakop_sdb_data";

///// iki asline ///
$mysqlUserName      = $username;
$mysqlPassword      = $password;
$mysqlHostName      = $hostname;
$dbname             = $dbname;

//$mysqlUserName      = "mitrakop_sdb_user";
//$mysqlPassword      = "Paktris4464100%";
//$mysqlHostName      = "localhost";
//$dbname             = "mitrakop_sdb_data";

Export_Database($mysqlHostName,$mysqlUserName,$mysqlPassword,$dbname,  $tables=false, $backup_name=false );
function Export_Database($host,$user,$pass,$name,  $tables=false, $backup_name=false )
{
    $mysqli = new mysqli($host,$user,$pass,$name); 
    $mysqli->select_db($name); 
    $mysqli->query("SET NAMES 'utf8'");
    $queryTables    = $mysqli->query('SHOW TABLES'); 
    while($row = $queryTables->fetch_row()) 
    { 
        $target_tables[] = $row[0]; 
    }   
    if($tables !== false) 
    { 
        $target_tables = array_intersect( $target_tables, $tables); 
    }
    foreach($target_tables as $table)
    {
        $result         =   $mysqli->query('SELECT * FROM '.$table);  
        $fields_amount  =   $result->field_count;  
        $rows_num=$mysqli->affected_rows;     
        $res            =   $mysqli->query('SHOW CREATE TABLE '.$table); 
        $TableMLine     =   $res->fetch_row();
        $content        = (!isset($content) ?  '' : $content) . "\n\n".$TableMLine[1].";\n\n";
        for ($i = 0, $st_counter = 0; $i < $fields_amount;   $i++, $st_counter=0) 
        {
            while($row = $result->fetch_row())  
                { //when started (and every after 100 command cycle):
                    if ($st_counter%100 == 0 || $st_counter == 0 )  
                    {
                        $content .= "\nINSERT INTO ".$table." VALUES";
                    }
                    $content .= "\n(";
                    for($j=0; $j<$fields_amount; $j++)  
                    { 
                        $row[$j] = str_replace("\n","\\n", addslashes($row[$j]) ); 
                        if (isset($row[$j]))
                        {
                            $content .= '"'.$row[$j].'"' ; 
                        }
                        else 
                        {   
                            $content .= '""';
                        }     
                        if ($j<($fields_amount-1))
                        {
                            $content.= ',';
                        }      
                    }
                    $content .=")";
                    //every after 100 command cycle [or at last line] ....p.s. but should be inserted 1 cycle eariler
                    if ( (($st_counter+1)%100==0 && $st_counter!=0) || $st_counter+1==$rows_num) 
                    {   
                        $content .= ";";
                    } 
                    else 
                    {
                        $content .= ",";
                    } 
                    $st_counter=$st_counter+1;
                }
            } $content .="\n\n\n";
        }
        
        $waktu = date('d-m-Y H_i_s');
        $backup_name = $name . "_".$waktu.".sql";
        // header('Content-Type: application/octet-stream');   
        // header("Content-Transfer-Encoding: Binary"); 
        // header("Content-disposition: attachment; filename=\"".$backup_name."\"");  
        // echo $content; 
        // exit;

        $myfile = fopen($backup_name, "w") or die("Unable to open file!");
        $txt = $content;
        fwrite($myfile, $txt);
        fclose($myfile);

        $dumpfname = $backup_name;

// zip the dump file
        $zipfname = $name . "_" . date("d_m_Y_H_i_s").".zip";
        $zip = new ZipArchive();
        if($zip->open($zipfname,ZIPARCHIVE::CREATE))
        {
            $zip->addFile($dumpfname,$dumpfname);
            $zip->close();
        }

// read zip file and send it to standard output
        if (file_exists($zipfname)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename='.basename($zipfname));
            flush();
            readfile($zipfname);
            unlink($backup_name);
        unlink($zipfname);
            exit;
        }




    }
?>